#ifndef __YC_CONF_H__
#define __YC_CONF_H__

/***************************************************************
 *                 ļӿ                            *
 *                                                             *
 *                                                             *
 *               yichen@wdyichen.cn                            *
 *       copyright (c) 2014 www.wdyichen.cn                    *
 *                                                             *
 ***************************************************************/


/*
 configure file example
 ****************************
 #example.conf
 [appname1]
 keyname1=value1
 keyname2=value2
 ...
 [appname2]
 keyname3=value3
 ...
*/


/*****************************************************************************
   (Prototype)    : yc_conf_get_key_4double
 (Description)  : ļжȡ
 (Input)        : pcFile        ļ
                          pcAppName     Ϊ
                          pcKeyName     
 (Output)       : pdKeyValue    ȡĸ
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/3
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_get_key_4double(IN  const char *pcFile,
                            IN  const char *pcAppName,
                            IN  const char *pcKeyName,
                            OUT double     *pdKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_get_key_4int
 (Description)  : ļжȡ
 (Input)        : pcFile        ļ
                          pcAppName     Ϊ
                          pcKeyName     
 (Output)       : piKeyValue    ȡ
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/3
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_get_key_4int(IN  const char *pcFile,
                         IN  const char *pcAppName,
                         IN  const char *pcKeyName,
                         OUT int        *piKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_get_key_4long
 (Description)  : ļжȡ
 (Input)        : pcFile        ļ
                          pcAppName     Ϊ
                          pcKeyName     
 (Output)       : plKeyValue    ȡĳ
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/3
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_get_key_4long(IN  const char *pcFile,
                          IN  const char *pcAppName,
                          IN  const char *pcKeyName,
                          OUT long       *plKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_get_key_4str
 (Description)  : ļжȡַ
 (Input)        : pcFile        ļ
                          pcAppName     ַΪ
                          pcKeyName     ַ
 (Output)       : pcKeyValue    ȡַ
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/3
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_get_key_4str(IN  const char *pcFile,
                         IN  const char *pcAppName,
                         IN  const char *pcKeyName,
                         OUT char       *pcKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_set_key_4str
 (Description)  : ַݴļ
 (Input)        : pcFile        ļ
                          pcAppName     ַΪ
                          pcKeyName     ַ
                          pcKeyValue    Ҫַ
 (Output)       : (None)
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/2
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_set_key_4str(IN const char *pcFile,
                         IN const char *pcAppName,
                         IN const char *pcKeyName,
                         IN const char *pcKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_set_key_4int
 (Description)  : ݴļ
 (Input)        : pcFile        ļ
                          pcAppName     Ϊ
                          pcKeyName     
                          iKeyValue     Ҫ
 (Output)       : (None)
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/2
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_set_key_4int(IN const char *pcFile,
                         IN const char *pcAppName,
                         IN const char *pcKeyName,
                         IN const int   iKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_set_key_4long
 (Description)  : ݴļ
 (Input)        : pcFile        ļ
                          pcAppName     Ϊ
                          pcKeyName     
                          lKeyValue     Ҫĳ
 (Output)       : (None)
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/2
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_set_key_4long(IN const char *pcFile,
                          IN const char *pcAppName,
                          IN const char *pcKeyName,
                          IN const long  lKeyValue);

/*****************************************************************************
   (Prototype)    : yc_conf_set_key_4double
 (Description)  : ݴļ
 (Input)        : pcFile        ļ
                          pcAppName     Ϊ
                          pcKeyName     
                          dKeyValue     Ҫĸ
 (Output)       : (None)
   ֵ(Return Value) : int       YC_ERROR_SUCCESS    ɹ(success)
                                    (other)         ʧ(fail)

 ޸ʷ(History)      :
  1.    (Date)         : 2014/8/2
        (Author)       : yichen
    ޸(Modification) : ɺ(Created function)

*****************************************************************************/
int yc_conf_set_key_4double(IN const char  *pcFile,
                            IN const char  *pcAppName,
                            IN const char  *pcKeyName,
                            IN const double dKeyValue);

#endif /* __YC_CONF_H__ */

